;;; DO NOT MODIFY THIS FILE
(if (featurep 'mule-base-autoloads) (error "Already loaded"))

;;;### (autoloads nil "_pkg" "mule-base/_pkg.el")

(package-provide 'mule-base :version 1.3 :type 'regular)

;;;***

;;;### (autoloads (view-charset) "char-table" "mule-base/char-table.el")

(autoload 'view-charset "char-table" "\
Display character table of CHARSET." t nil)

;;;***

;;;### (autoloads (view-charset-by-menu) "chartblxmas" "mule-base/chartblxmas.el")

(autoload 'view-charset-by-menu "chartblxmas" "\
Display character table of CHARSET by pop-up menu." t nil)

;;;***

;;;### (autoloads (encode-hz-buffer encode-hz-region decode-hz-buffer decode-hz-region setup-chinese-big5-environment setup-chinese-gb-environment) "china-util" "mule-base/china-util.el")

(autoload 'setup-chinese-gb-environment "china-util" "\
Setup multilingual environment (MULE) for Chinese GB2312 users." t nil)

(autoload 'setup-chinese-big5-environment "china-util" "\
Setup multilingual environment (MULE) for Chinese Big5 users." t nil)

(autoload 'decode-hz-region "china-util" "\
Decode HZ/ZW encoded text in the current region.
Return the length of resulting text." t nil)

(autoload 'decode-hz-buffer "china-util" "\
Decode HZ/ZW encoded text in the current buffer." t nil)

(autoload 'encode-hz-region "china-util" "\
Encode the text in the current region to HZ.
Return the length of resulting text." t nil)

(autoload 'encode-hz-buffer "china-util" "\
Encode the text in the current buffer to HZ." t nil)

;;;***

;;;### (autoloads (standard-display-cyrillic-translit setup-cyrillic-alternativnyj-environment setup-cyrillic-koi8-environment setup-cyrillic-iso-environment) "cyril-util" "mule-base/cyril-util.el")

(autoload 'setup-cyrillic-iso-environment "cyril-util" "\
Setup multilingual environment (MULE) for Cyrillic ISO-8859-5 users." t nil)

(autoload 'setup-cyrillic-koi8-environment "cyril-util" "\
Setup multilingual environment (MULE) for Cyrillic KOI8 users." t nil)

(autoload 'setup-cyrillic-alternativnyj-environment "cyril-util" "\
Setup multilingual environment (MULE) for Cyrillic ALTERNATIVNYJ users." t nil)

(autoload 'standard-display-cyrillic-translit "cyril-util" "\
Display a cyrillic buffer using a transliteration.
For readability, the table is slightly
different from the one used for the input method `cyrillic-translit'.

The argument is a string which specifies which language you are using;
that affects the choice of transliterations slightly.
Possible values are listed in 'cyrillic-language-alist'.
If the argument is t, we use the default cyrillic transliteration.
If the argument is nil, we return the display table to its standard state." t nil)

;;;***

;;;### (autoloads (isearch-fep-quail isearch-fep-canna isearch-fep-egg isearch-fep-string) "isearch-mule" "mule-base/isearch-mule.el")

(defvar search-string-char-prompt "*Enter string... ")

(autoload 'isearch-fep-string "isearch-mule" "\
Read string from minibuffer for incremental search." t nil)

(autoload 'isearch-fep-egg "isearch-mule" "\
Read string for incremental search by using egg." t nil)

(autoload 'isearch-fep-canna "isearch-mule" "\
Read string for incremental search by using canna." t nil)

(autoload 'isearch-fep-quail "isearch-mule" "\
Read string for incremental search by using quail." t nil)

;;;***

;;;### (autoloads (read-hiragana-string japanese-zenkaku-region japanese-hankaku-region japanese-hiragana-region japanese-katakana-region japanese-zenkaku japanese-hankaku japanese-hiragana japanese-katakana setup-japanese-environment) "japan-util" "mule-base/japan-util.el")

(autoload 'setup-japanese-environment "japan-util" "\
Setup multilingual environment (MULE) for Japanese." t nil)

(autoload 'japanese-katakana "japan-util" "\
Convert argument to Katakana and return that.
The argument may be a character or string.  The result has the same type.
The argument object is not altered--the value is a copy.
Optional argument HANKAKU t means to convert to `hankaku' Katakana
 (`japanese-jisx0201-kana'), in which case return value
 may be a string even if OBJ is a character if two Katakanas are
 necessary to represent OBJ." nil nil)

(autoload 'japanese-hiragana "japan-util" "\
Convert argument to Hiragana and return that.
The argument may be a character or string.  The result has the same type.
The argument object is not altered--the value is a copy." nil nil)

(autoload 'japanese-hankaku "japan-util" "\
Convert argument to `hankaku' and return that.
The argument may be a character or string.  The result has the same type.
The argument object is not altered--the value is a copy.
Optional argument ASCII-ONLY non-nil means to return only ASCII character." nil nil)

(autoload 'japanese-zenkaku "japan-util" "\
Convert argument to `zenkaku' and return that.
The argument may be a character or string.  The result has the same type.
The argument object is not altered--the value is a copy." nil nil)

(autoload 'japanese-katakana-region "japan-util" "\
Convert Japanese `hiragana' chars in the region to `katakana' chars.
Optional argument HANKAKU t means to convert to `hankaku katakana' character
of which charset is `japanese-jisx0201-kana'." t nil)

(autoload 'japanese-hiragana-region "japan-util" "\
Convert Japanese `katakana' chars in the region to `hiragana'  chars." t nil)

(autoload 'japanese-hankaku-region "japan-util" "\
Convert Japanese `zenkaku' chars in the region to `hankaku' chars.
`Zenkaku' chars belong to `japanese-jisx0208'
`Hankaku' chars belong to `ascii' or `japanese-jisx0201-kana'.
Optional argument ASCII-ONLY non-nil means to convert only to ASCII char." t nil)

(autoload 'japanese-zenkaku-region "japan-util" "\
Convert hankaku' chars in the region to Japanese `zenkaku' chars.
`Zenkaku' chars belong to `japanese-jisx0208'
`Hankaku' chars belong to `ascii' or `japanese-jisx0201-kana'." t nil)

(autoload 'read-hiragana-string "japan-util" "\
Read a Hiragana string from the minibuffer, prompting with string PROMPT.
If non-nil, second arg INITIAL-INPUT is a string to insert before reading." nil nil)

;;;***

;;;### (autoloads (kana-keyboard-define-keys) "kana-keyboard" "mule-base/kana-keyboard.el")

(autoload 'kana-keyboard-define-keys "kana-keyboard" nil nil nil)

;;;***

;;;### (autoloads (dump-coding-systems dump-charsets mule-diag list-fontset describe-fontset list-font describe-font list-coding-system list-coding-system-briefly list-charsets) "mule-debug" "mule-base/mule-debug.el")

(autoload 'list-charsets "mule-debug" "\
Display a list of existing character sets." t nil)

(autoload 'list-coding-system-briefly "mule-debug" "\
Display coding-systems currently used with a brief format in mini-buffer." t nil)

(autoload 'list-coding-system "mule-debug" "\
Describe coding-systems currently used with a detailed format.
If optional arg ALL is non-nil, all coding-systems are listed in
machine readable simple format." t nil)

(autoload 'describe-font "mule-debug" "\
Display information about fonts which partially match FONTNAME." t nil)

(autoload 'list-font "mule-debug" "\
Display a list of fonts." t nil)

(autoload 'describe-fontset "mule-debug" "\
Display information about FONTSET." t nil)

(autoload 'list-fontset "mule-debug" "\
Display a list of fontsets." t nil)

(autoload 'mule-diag "mule-debug" "\
Show diagnosis of the current running Mule." t nil)

(autoload 'dump-charsets "mule-debug" nil nil nil)

(autoload 'dump-coding-systems "mule-debug" nil nil nil)

;;;***

;;;### (autoloads (dump-codings dump-charsets mule-diag list-input-methods list-fontsets describe-fontset describe-font list-coding-systems describe-current-coding-system describe-current-coding-system-briefly describe-coding-system list-character-sets) "mule-diag" "mule-base/mule-diag.el")

(autoload 'list-character-sets "mule-diag" "\
Display a list of all character sets.

The ID column contains a charset identification number for internal use.
The B column contains a number of bytes occupied in a buffer.
The W column contains a number of columns occupied in a screen.

With prefix arg, the output format gets more cryptic
but contains full information about each character sets." t nil)

(autoload 'describe-coding-system "mule-diag" "\
Display information of CODING-SYSTEM." t nil)

(autoload 'describe-current-coding-system-briefly "mule-diag" "\
Display coding systems currently used in a brief format in echo area.

The format is \"F[..],K[..],T[..],P>[..],P<[..], default F[..],P<[..],P<[..]\",
where mnemonics of the following coding systems come in this order
at the place of `..':
  buffer-file-coding-system (of the current buffer)
  eol-type of buffer-file-coding-system (of the current buffer)
  (keyboard-coding-system)
  eol-type of (keyboard-coding-system)
  (terminal-coding-system)
  eol-type of (terminal-coding-system)
  process-coding-system for read (of the current buffer, if any)
  eol-type of process-coding-system for read (of the current buffer, if any)
  process-coding-system for write (of the current buffer, if any)
  eol-type of process-coding-system for write (of the current buffer, if any)
  default-buffer-file-coding-system
  eol-type of default-buffer-file-coding-system
  default-process-coding-system for read
  eol-type of default-process-coding-system for read
  default-process-coding-system for write
  eol-type of default-process-coding-system" t nil)

(autoload 'describe-current-coding-system "mule-diag" "\
Display coding systems currently used in a detailed format." t nil)

(autoload 'list-coding-systems "mule-diag" "\
Display a list of all coding systems.
It prints mnemonic letter, name, and description of each coding systems.

With prefix arg, the output format gets more cryptic,
but contains full information about each coding systems." t nil)

(autoload 'describe-font "mule-diag" "\
Display information about fonts which partially match FONTNAME." t nil)

(autoload 'describe-fontset "mule-diag" "\
Display information of FONTSET.

It prints name, size, and style of FONTSET, and lists up fonts
contained in FONTSET.

The column WDxHT contains width and height (pixels) of each fontset
\(i.e. those of ASCII font in the fontset).  The letter `-' in this
column means that the corresponding fontset is not yet used in any
frame.

The O column of each font contains one of the following letters.
 o -- font already opened
 - -- font not yet opened
 x -- font can't be opened
 ? -- no font specified

The Charset column of each font contains a name of character set
displayed by the font." t nil)

(autoload 'list-fontsets "mule-diag" "\
Display a list of all fontsets.

It prints name, size, and style of each fontset.
With prefix arg, it also lists up fonts contained in each fontset.
See the function `describe-fontset' for the format of the list." t nil)

(autoload 'list-input-methods "mule-diag" "\
Print information of all input methods." t nil)

(autoload 'mule-diag "mule-diag" "\
Display diagnosis of the multilingual environment (MULE).

It prints various information related to the current multilingual
environment, including lists of input methods, coding systems,
character sets, and fontsets (if Emacs running under some window
system)." t nil)

(autoload 'dump-charsets "mule-diag" "\
Dump information of all charsets into the file \"CHARSETS\".
The file is saved in the directory `data-directory'." nil nil)

(autoload 'dump-codings "mule-diag" "\
Dump information of all coding systems into the file \"CODINGS\".
The file is saved in the directory `data-directory'." nil nil)

;;;***

;;;### (autoloads (set-keyboard-coding-system) "mule-keyboard" "mule-base/mule-keyboard.el")

(defvar keyboard-allow-latin-input nil "\
If non-nil, \"ESC , Fe\" and \"ESC - Fe\" are used for inputting
Latin characters.")

(autoload 'set-keyboard-coding-system "mule-keyboard" "\
Set variable keyboard-coding-system to CODESYS and modify keymap for it." t nil)

;;;***

;;;### (autoloads (define-word-regexp regexp-word-compile regexp-compile) "mule-trex" "mule-base/mule-trex.el")

(autoload 'regexp-compile "mule-trex" nil nil nil)

(autoload 'regexp-word-compile "mule-trex" nil nil nil)

(autoload 'define-word-regexp "mule-trex" nil nil 'macro)

;;;***

;;;### (autoloads (decompose-composite-char compose-chars decompose-region compose-region set-coding-system-alist lookup-nested-alist set-nested-alist nested-alist-p) "mule-util" "mule-base/mule-util.el")

(autoload 'nested-alist-p "mule-util" "\
Return t if OBJ is a nesetd alist.

Nested alist is a list of the form (ENTRY . BRANCHES), where ENTRY is
any Lisp object, and BRANCHES is a list of cons cells of the form
\(KEY-ELEMENT . NESTED-ALIST).

You can use a nested alist to store any Lisp object (ENTRY) for a key
sequence KEYSEQ, where KEYSEQ is a sequence of KEY-ELEMENT.  KEYSEQ
can be a string, a vector, or a list." nil nil)

(autoload 'set-nested-alist "mule-util" "\
Set ENTRY for KEYSEQ in a nested alist ALIST.
Optional 4th arg LEN non-nil means the firlst LEN elements in KEYSEQ
 is considered.
Optional argument BRANCHES if non-nil is branches for a keyseq
longer than KEYSEQ.
See the documentation of `nested-alist-p' for more detail." nil nil)

(autoload 'lookup-nested-alist "mule-util" "\
Look up key sequence KEYSEQ in nested alist ALIST.  Return the definition.
Optional 1st argument LEN specifies the length of KEYSEQ.
Optional 2nd argument START specifies index of the starting key.
The returned value is normally a nested alist of which
car part is the entry for KEYSEQ.
If ALIST is not deep enough for KEYSEQ, return number which is
 how many key elements at the front of KEYSEQ it takes
 to reach a leaf in ALIST.
Optional 3rd argument NIL-FOR-TOO-LONG non-nil means return nil
 even if ALIST is not deep enough." nil nil)

(autoload 'set-coding-system-alist "mule-util" "\
Update `coding-system-alist' according to the arguments.
TARGET-TYPE specifies a type of the target: `file', `process', or `network'.
  TARGET-TYPE tells which slots of coding-system-alist should be affected.
  If `file', it affects slots for insert-file-contents and write-region.
  If `process', it affects slots for call-process, call-process-region, and
    start-process.
  If `network', it affects a slot for open-network-process.
REGEXP is a regular expression matching a target of I/O operation.
CODING-SYSTEM is a coding system to perform code conversion
  on the I/O operation, or a cons of coding systems for decoding and
  encoding respectively, or a function symbol which returns the cons.
Optional arg OPERATION if non-nil specifies directly one of slots above.
  The valid value is: insert-file-contents, write-region,
  call-process, call-process-region, start-process, or open-network-stream.
If OPERATION is specified, TARGET-TYPE is ignored.
See the documentation of `coding-system-alist' for more detail." nil nil)

(autoload 'compose-region "mule-util" "\
Compose characters in the current region into one composite character.
From a Lisp program, pass two arguments, START to END.
The composite character replaces the composed characters.
BUFFER defaults to the current buffer if omitted." t nil)

(autoload 'decompose-region "mule-util" "\
Decompose any composite characters in the current region.
From a Lisp program, pass two arguments, START to END.
This converts each composite character into one or more characters,
the individual characters out of which the composite character was formed.
Non-composite characters are left as-is.  BUFFER defaults to the current
buffer if omitted." t nil)

(defconst reference-point-alist '((tl . 0) (tc . 1) (tr . 2) (ml . 3) (mc . 4) (mr . 5) (bl . 6) (bc . 7) (br . 8) (top-left . 0) (top-center . 1) (top-right . 2) (mid-left . 3) (mid-center . 4) (mid-right . 5) (bottom-left . 6) (bottom-center . 7) (bottom-right . 8) (0 . 0) (1 . 1) (2 . 2) (3 . 3) (4 . 4) (5 . 5) (6 . 6) (7 . 7) (8 . 8)) "\
Alist of reference point symbols vs reference point codes.
Meanings of reference point codes are as follows:

    0----1----2 <-- ascent	0:tl or top-left
    |         |			1:tc or top-center
    |         |			2:tr or top-right
    |         |			3:ml or mid-left
    |    4 <--+---- center	4:mc or mid-center
    |         |			5:mr or mid-right
--- 3         5 <-- baseline	6:bl or bottom-left
    |         |			7:bc or bottom-center
    6----7----8 <-- descent	8:br or bottom-right

Reference point symbols are to be used to specify composition rule of
the form (GLOBAL-REF-POINT . NEW-REF-POINT), where GLOBAL-REF-POINT
is a reference point in the overall glyphs already composed, and
NEW-REF-POINT is a reference point in the new glyph to be added.

For instance, if GLOBAL-REF-POINT is 8 and NEW-REF-POINT is 1, the
overall glyph is updated as follows:

    +-------+--+ <--- new ascent
    |       |  |
    | global|  |
    | glyph |  |
--- |       |  | <--- baseline (doesn't change)
    +----+--+--+
    |    | new |
    |    |glyph|
    +----+-----+ <--- new descent
")

(autoload 'compose-chars "mule-util" "\
Return one char string composed from the arguments.
Each argument is a character (including a composite chararacter)
or a composition rule.
A composition rule has the form (GLOBAL-REF-POINT . NEW-REF-POINT).
See the documentation of `reference-point-alist' for more detail." nil nil)

(autoload 'decompose-composite-char "mule-util" "\
Convert composite character CHAR to a string containing components of CHAR.
Optional 1st arg TYPE specifies the type of sequence returned.
It should be `string' (default), `list', or `vector'.
Optional 2nd arg WITH-COMPOSITION-RULE non-nil means the returned
sequence contains embedded composition rules if any.  In this case, the
order of elements in the sequence is the same as arguments for
`compose-chars' to create CHAR.
If TYPE is omitted or is `string', composition rules are omitted
even if WITH-COMPOSITION-RULE is t." nil nil)

;;;***

;;;### (autoloads (viqr-pre-write-conversion viqr-post-read-conversion viet-encode-viqr-buffer viet-encode-viqr-region viet-decode-viqr-buffer viet-decode-viqr-region setup-vietnamese-environment viet-encode-viscii-char) "viet-util" "mule-base/viet-util.el")

(autoload 'viet-encode-viscii-char "viet-util" "\
Return VISCII character code of CHAR if appropriate." nil nil)

(autoload 'setup-vietnamese-environment "viet-util" "\
Setup multilingual environment (MULE) for Vietnamese VISCII users." t nil)

(autoload 'viet-decode-viqr-region "viet-util" "\
Convert `VIQR' mnemonics of the current region to Vietnamese characaters.
When called from a program, expects two arguments,
positions (integers or markers) specifying the stretch of the region." t nil)

(autoload 'viet-decode-viqr-buffer "viet-util" "\
Convert `VIQR' mnemonics of the current buffer to Vietnamese characaters." t nil)

(autoload 'viet-encode-viqr-region "viet-util" "\
Convert Vietnamese characaters of the current region to `VIQR' mnemonics.
When called from a program, expects two arguments,
positions (integers or markers) specifying the stretch of the region." t nil)

(autoload 'viet-encode-viqr-buffer "viet-util" "\
Convert Vietnamese characaters of the current buffer to `VIQR' mnemonics." t nil)

(autoload 'viqr-post-read-conversion "viet-util" nil nil nil)

(autoload 'viqr-pre-write-conversion "viet-util" nil nil nil)

;;;***

(provide 'mule-base-autoloads)
