;;; DO NOT MODIFY THIS FILE
(if (featurep 'jde-autoloads) (error "Already loaded"))

;;;### (autoloads nil "_pkg" "jde/_pkg.el")

(package-provide 'jde :version 1.14 :type 'regular)

;;;***

;;;### (autoloads (jde-compile jde-set-compile-options) "jde-compile" "jde/jde-compile.el")

(autoload 'jde-set-compile-options "jde-compile" "\
Sets the compile options.
Enter the options as you would on the command line, e.g.,
-depend -verbose." t nil)

(autoload 'jde-compile "jde-compile" "\
Compile the Java program in the current buffer.
This command invokes the compiler specified by `jde-compiler'
with the options specified by the JDE customization variables
that begin with `jde-compile'. If the variable
`jde-read-compile-args' is non-nil, this command reads
additional compilation options from the minibuffer, with
history enabled." t nil)

;;;***

;;;### (autoloads (jde-db-set-source-paths jde-db jde-db-set-app-args jde-db-set-args jde-db-set-debugger) "jde-db" "jde/jde-db.el")

(autoload 'jde-db-set-debugger "jde-db" "\
Specify the pathname of the debugger, if an executable, or the
debugger's fully qualified class name, if a class." t nil)

(autoload 'jde-db-set-args "jde-db" "\
Specify the arguments (except -classpath) to be passed to the debugger." t nil)

(autoload 'jde-db-set-app-args "jde-db" "\
Specify the arguments to be passed to the Java application class." t nil)

(autoload 'jde-db "jde-db" "\
Run jdb on Java class whose source resides in the current buffer.
This command creates a command buffer named *gud-CLASS* for the debug session.
CLASS is the name of the class you are debugging." t nil)

(autoload 'jde-db-set-source-paths "jde-db" "\
Set the source path list used by JDE to locate Java source files visited
by the debugger. PATHS is a list of source paths separated by colons or semicolons,
depending on the operating system.. Note that for packages, you need enter only the 
directory containing the top-level package. For example, including '../jdk1.1/src/'
 enables the JDE to  locate all source files provided with JDK1.1. Note also that the 
paths must end in a slash." t nil)

;;;***

;;;### (autoloads (jde-gen-buffer jde-gen-jfc-app-buffer jde-gen-console-buffer jde-gen-class-buffer) "jde-gen" "jde/jde-gen.el")

(autoload 'jde-gen-class-buffer "jde-gen" "\
Create a new Java buffer containing a class of the same name.
This command inserts the class template generated by `jde-gen-class'.
It then moves the point to the location to the constructor." t nil)

(autoload 'jde-gen-console-buffer "jde-gen" "\
Create a new Java buffer containing a console class of the same name.
This command inserts the class template generated by `jde-gen-class'.
It then moves the point to the location to the constructor." t nil)

(autoload 'jde-gen-jfc-app-buffer "jde-gen" "\
Create a new Java buffer containing a JFC application class.
This command inserts the class template generated by `jde-gen-jfc-app'.
It then moves the point to the location to the constructor." t nil)

(autoload 'jde-gen-buffer "jde-gen" "\
Create a new Java buffer containing a code template.
This command inserts the specified template at the beginning
of the buffer." t nil)

;;;***

;;;### (autoloads (jde-make) "jde-make" "jde/jde-make.el")

(autoload 'jde-make "jde-make" "\
Run the JDE make program." t nil)

;;;***

;;;### (autoloads (jde-run-applet jde-run-mode jde-run jde-run-set-applet-doc jde-run-set-applet-viewer jde-run-set-app-args jde-run-set-args jde-run-set-app jde-run-set-vm-w jde-run-set-vm) "jde-run" "jde/jde-run.el")

(autoload 'jde-run-set-vm "jde-run" "\
Specifies the Java interpreter used to run Java applications
on non-Windows platforms . The default is java." t nil)

(autoload 'jde-run-set-vm-w "jde-run" "\
Specifies the Java interpreter used to run Java applications
on Windows platforms . The default is javaw." t nil)

(autoload 'jde-run-set-app "jde-run" "\
Specify the name of the application class to run." t nil)

(autoload 'jde-run-set-args "jde-run" "\
Specify arguments to be passed to the Java vm.
This command serves as an alternative to using the JDE Run Options
panel to specify command-line arguments for the Java interpreter." t nil)

(autoload 'jde-run-set-app-args "jde-run" "\
Specify the arguments to be passed to the Java application class.
This command provides an alternative to using the JDE Run Options panel
to specify command-line arguments to pass to the application when starting
the application." t nil)

(autoload 'jde-run-set-applet-viewer "jde-run" "\
Sets the viewer to be used to view an applet. The default is 
appletviewer." t nil)

(autoload 'jde-run-set-applet-doc "jde-run" "\
Specify the doc to be used to view an applet.
This command provides an alternative to using the JDE Options
panel to specifying the applet document." t nil)

(autoload 'jde-run "jde-run" "\
Runs the Java program named by jde-run-application-class in
a buffer, piping output from the program to the buffer and 
input from the buffer to the program." t nil)

(autoload 'jde-run-mode "jde-run" "\
Mode for running Java programs." t nil)

(autoload 'jde-run-applet "jde-run" "\
Run an applet, using the viewer specified by jde-run-applet-viewer
and the applet document specified by jde-run-applet-doc." t nil)

;;;***

;;;### (autoloads (jde-show-help jde-save-project jde-open-project-file jde-mode jde-build jde-java-build jde-browse-jdk-doc jde-set-global-classpath jde-set-compiler) "jde" "jde/jde.el")

(defconst jde-version "2.1.4" "\
JDE version number.")

(autoload 'jde-set-compiler "jde" "\
Specify the pathname of the compiler to be used to compile the
current buffer. Default is javac." t nil)

(autoload 'jde-set-global-classpath "jde" "\
Specify the value of the -classpath argument for the Java compiler and
interpreter." t nil)

(autoload 'jde-browse-jdk-doc "jde" "\
Displays the JDK doc in a web browser. This function uses the URL
stored in the variable jde-jdk-doc-url to locate the JDK documentation." t nil)

(autoload 'jde-java-build "jde" "\
Use javac -depend to build the application whose main class is
specified by `jde-run-application-class'." t nil)

(autoload 'jde-build "jde" "\
Rebuild the entire project.
This command has two operating modes: java and make. In java mode,
this command uses javac's built-in make facility to rebuild a
project. In make mode, this command uses a user-specified make program
to rebuild the project. JDE configuration variables control which mode
is used.  In particular, if the variable `jde-build-use-make' is
non-nil, this command invokes the make program specified by the
variable `jde-make-program'. If the variable `jde-make-args' is a
non-empty string, this function uses its contents to invoke make;
otherwise, it prompts you to enter command-line arguments for make. If
`jde-build-use-make' is nil, this function invokes javac on the source
file specified by `jde-run-app-class', with the -depend option. This
causes javac to recompile all missing or out-of-date files required
to run the application's main class." t nil)

(autoload 'jde-mode "jde" "\
Major mode for developing Java applications and applets." nil nil)

(setq auto-mode-alist (append '(("\\.java\\'" . jde-mode)) auto-mode-alist))

(autoload 'jde-open-project-file "jde" "\
Opens the project file for the Java source file in the
current buffer." t nil)

(autoload 'jde-save-project "jde" "\
Saves local source file buffer options in project file.
This command provides an easy way to create and update a
project file for a Java project. Simply open a source file,
set the desired options, using the JDE Options menu, then
save the settings in the project file, using this command.
Now, whenever you open a source file from the same directory
tree, the saved settings will be restored for that file." t nil)

(autoload 'jde-show-help "jde" "\
Displays the JDE User's Guide in a browser." t nil)

;;;***

(provide 'jde-autoloads)
